<?php

namespace App\Utils;

class Japanese
{
    public static function getOnlyKanji(string $str): string
    {
        return preg_replace('/[^\p{Script=Han}]/u', '', $str);
    }

    /** Get the number of kanji of a string that are not in the given set
     *  of kanji
     *
     * Only kanji are considere, not katakana, hiragana or any other symbols.
     *
     * @param list<string> $kanjiSet
     */
    public static function kanjiDiff(string $str, array $kanjiSet): int
    {
        $ret = 0;

        $strKanji = self::getOnlyKanji($str);
        $len = mb_strlen($strKanji);
        for ($i = 0; $i < $len; $i++) {
            $kanji = mb_substr($strKanji, $i, 1);

            if (!array_search($kanji, $kanjiSet)) {
                $ret++;
            }
        }

        //dump($str, $strKanji, $ret);
        //echo "\n";

        return $ret;
    }
}
